"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeArrayNode = exports.isTypeArrayNode = exports.TypeArrayNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeArrayNode {
    constructor(itemType, size) {
        this.nodeClass = 'TypeArrayNode';
        this.itemType = itemType;
        this.size = size;
    }
    static fromIdl(idl) {
        const itemType = (0, TypeNode_1.createTypeNodeFromIdl)(idl.array[0]);
        return new TypeArrayNode(itemType, idl.array[1]);
    }
    accept(visitor) {
        return visitor.visitTypeArray(this);
    }
}
exports.TypeArrayNode = TypeArrayNode;
function isTypeArrayNode(node) {
    return !!node && node.nodeClass === 'TypeArrayNode';
}
exports.isTypeArrayNode = isTypeArrayNode;
function assertTypeArrayNode(node) {
    var _a;
    if (!isTypeArrayNode(node)) {
        throw new Error(`Expected TypeArrayNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeArrayNode = assertTypeArrayNode;
//# sourceMappingURL=TypeArrayNode.js.map