"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeDefinedLinkNode = exports.isTypeDefinedLinkNode = exports.TypeDefinedLinkNode = void 0;
const utils_1 = require("../utils");
class TypeDefinedLinkNode {
    constructor(definedType, dependency = null) {
        this.nodeClass = 'TypeDefinedLinkNode';
        this.definedType = (0, utils_1.mainCase)(definedType);
        this.dependency = dependency;
    }
    accept(visitor) {
        return visitor.visitTypeDefinedLink(this);
    }
    get name() {
        return this.definedType;
    }
}
exports.TypeDefinedLinkNode = TypeDefinedLinkNode;
function isTypeDefinedLinkNode(node) {
    return !!node && node.nodeClass === 'TypeDefinedLinkNode';
}
exports.isTypeDefinedLinkNode = isTypeDefinedLinkNode;
function assertTypeDefinedLinkNode(node) {
    var _a;
    if (!isTypeDefinedLinkNode(node)) {
        throw new Error(`Expected TypeDefinedLinkNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeDefinedLinkNode = assertTypeDefinedLinkNode;
//# sourceMappingURL=TypeDefinedLinkNode.js.map