"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeEnumStructVariantNode = exports.isTypeEnumStructVariantNode = exports.TypeEnumStructVariantNode = void 0;
const utils_1 = require("../utils");
const TypeStructNode_1 = require("./TypeStructNode");
class TypeEnumStructVariantNode {
    constructor(name, struct) {
        this.nodeClass = 'TypeEnumStructVariantNode';
        this.name = (0, utils_1.mainCase)(name);
        this.struct = struct;
    }
    static fromIdl(idl) {
        var _a;
        const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
        return new TypeEnumStructVariantNode(name, TypeStructNode_1.TypeStructNode.fromIdl({
            kind: 'struct',
            name,
            fields: idl.fields,
        }));
    }
    accept(visitor) {
        return visitor.visitTypeEnumStructVariant(this);
    }
}
exports.TypeEnumStructVariantNode = TypeEnumStructVariantNode;
function isTypeEnumStructVariantNode(node) {
    return !!node && node.nodeClass === 'TypeEnumStructVariantNode';
}
exports.isTypeEnumStructVariantNode = isTypeEnumStructVariantNode;
function assertTypeEnumStructVariantNode(node) {
    var _a;
    if (!isTypeEnumStructVariantNode(node)) {
        throw new Error(`Expected TypeEnumStructVariantNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeEnumStructVariantNode = assertTypeEnumStructVariantNode;
//# sourceMappingURL=TypeEnumStructVariantNode.js.map