"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeEnumTupleVariantNode = exports.isTypeEnumTupleVariantNode = exports.TypeEnumTupleVariantNode = void 0;
const utils_1 = require("../utils");
const TypeTupleNode_1 = require("./TypeTupleNode");
class TypeEnumTupleVariantNode {
    constructor(name, tuple) {
        this.nodeClass = 'TypeEnumTupleVariantNode';
        this.name = (0, utils_1.mainCase)(name);
        this.tuple = tuple;
    }
    static fromIdl(idl) {
        var _a;
        const name = (_a = idl.name) !== null && _a !== void 0 ? _a : '';
        return new TypeEnumTupleVariantNode(name, TypeTupleNode_1.TypeTupleNode.fromIdl({ tuple: idl.fields }));
    }
    accept(visitor) {
        return visitor.visitTypeEnumTupleVariant(this);
    }
}
exports.TypeEnumTupleVariantNode = TypeEnumTupleVariantNode;
function isTypeEnumTupleVariantNode(node) {
    return !!node && node.nodeClass === 'TypeEnumTupleVariantNode';
}
exports.isTypeEnumTupleVariantNode = isTypeEnumTupleVariantNode;
function assertTypeEnumTupleVariantNode(node) {
    var _a;
    if (!isTypeEnumTupleVariantNode(node)) {
        throw new Error(`Expected TypeEnumTupleVariantNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeEnumTupleVariantNode = assertTypeEnumTupleVariantNode;
//# sourceMappingURL=TypeEnumTupleVariantNode.js.map