"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeLeafWrapperNode = exports.isTypeLeafWrapperNode = exports.TypeLeafWrapperNode = void 0;
class TypeLeafWrapperNode {
    constructor(wrapper, leaf) {
        this.nodeClass = 'TypeLeafWrapperNode';
        this.wrapper = wrapper;
        this.leaf = leaf;
    }
    accept(visitor) {
        return visitor.visitTypeLeafWrapper(this);
    }
}
exports.TypeLeafWrapperNode = TypeLeafWrapperNode;
function isTypeLeafWrapperNode(node) {
    return !!node && node.nodeClass === 'TypeLeafWrapperNode';
}
exports.isTypeLeafWrapperNode = isTypeLeafWrapperNode;
function assertTypeLeafWrapperNode(node) {
    var _a;
    if (!isTypeLeafWrapperNode(node)) {
        throw new Error(`Expected TypeLeafWrapperNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeLeafWrapperNode = assertTypeLeafWrapperNode;
//# sourceMappingURL=TypeLeafWrapperNode.js.map