"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeMapNode = exports.isTypeMapNode = exports.TypeMapNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeMapNode {
    constructor(mapType, keyType, valueType) {
        this.nodeClass = 'TypeMapNode';
        this.mapType = mapType;
        this.keyType = keyType;
        this.valueType = valueType;
    }
    static fromIdl(idl) {
        const mapType = 'hashMap' in idl ? 'hashMap' : 'bTreeMap';
        const [key, value] = 'hashMap' in idl ? idl.hashMap : idl.bTreeMap;
        const keyType = (0, TypeNode_1.createTypeNodeFromIdl)(key);
        const valueType = (0, TypeNode_1.createTypeNodeFromIdl)(value);
        return new TypeMapNode(mapType, keyType, valueType);
    }
    accept(visitor) {
        return visitor.visitTypeMap(this);
    }
}
exports.TypeMapNode = TypeMapNode;
function isTypeMapNode(node) {
    return !!node && node.nodeClass === 'TypeMapNode';
}
exports.isTypeMapNode = isTypeMapNode;
function assertTypeMapNode(node) {
    var _a;
    if (!isTypeMapNode(node)) {
        throw new Error(`Expected TypeMapNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeMapNode = assertTypeMapNode;
//# sourceMappingURL=TypeMapNode.js.map