"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeOptionNode = exports.isTypeOptionNode = exports.TypeOptionNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeOptionNode {
    constructor(optionType, type) {
        this.nodeClass = 'TypeOptionNode';
        this.optionType = optionType;
        this.type = type;
    }
    static fromIdl(idl) {
        const optionType = 'option' in idl ? 'option' : 'coption';
        const idlType = 'option' in idl ? idl.option : idl.coption;
        return new TypeOptionNode(optionType, (0, TypeNode_1.createTypeNodeFromIdl)(idlType));
    }
    accept(visitor) {
        return visitor.visitTypeOption(this);
    }
}
exports.TypeOptionNode = TypeOptionNode;
function isTypeOptionNode(node) {
    return !!node && node.nodeClass === 'TypeOptionNode';
}
exports.isTypeOptionNode = isTypeOptionNode;
function assertTypeOptionNode(node) {
    var _a;
    if (!isTypeOptionNode(node)) {
        throw new Error(`Expected TypeOptionNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeOptionNode = assertTypeOptionNode;
//# sourceMappingURL=TypeOptionNode.js.map