"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeSetNode = exports.isTypeSetNode = exports.TypeSetNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeSetNode {
    constructor(setType, type) {
        this.nodeClass = 'TypeSetNode';
        this.setType = setType;
        this.type = type;
    }
    static fromIdl(idl) {
        const setType = 'hashSet' in idl ? 'hashSet' : 'bTreeSet';
        const idlType = 'hashSet' in idl ? idl.hashSet : idl.bTreeSet;
        return new TypeSetNode(setType, (0, TypeNode_1.createTypeNodeFromIdl)(idlType));
    }
    accept(visitor) {
        return visitor.visitTypeSet(this);
    }
}
exports.TypeSetNode = TypeSetNode;
function isTypeSetNode(node) {
    return !!node && node.nodeClass === 'TypeSetNode';
}
exports.isTypeSetNode = isTypeSetNode;
function assertTypeSetNode(node) {
    var _a;
    if (!isTypeSetNode(node)) {
        throw new Error(`Expected TypeSetNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeSetNode = assertTypeSetNode;
//# sourceMappingURL=TypeSetNode.js.map