"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeStructFieldNode = exports.isTypeStructFieldNode = exports.TypeStructFieldNode = void 0;
const utils_1 = require("../utils");
const TypeNode_1 = require("./TypeNode");
const ValueNode_1 = require("./ValueNode");
class TypeStructFieldNode {
    constructor(metadata, type) {
        this.nodeClass = 'TypeStructFieldNode';
        this.metadata = { ...metadata, name: (0, utils_1.mainCase)(metadata.name) };
        this.type = type;
    }
    static fromIdl(idl) {
        var _a, _b;
        return new TypeStructFieldNode({
            name: (_a = idl.name) !== null && _a !== void 0 ? _a : '',
            docs: (_b = idl.docs) !== null && _b !== void 0 ? _b : [],
            defaultsTo: idl.defaultsValue !== undefined
                ? { strategy: 'optional', value: (0, ValueNode_1.vScalar)(idl.defaultsValue) }
                : null,
        }, (0, TypeNode_1.createTypeNodeFromIdl)(idl.type));
    }
    accept(visitor) {
        return visitor.visitTypeStructField(this);
    }
    get name() {
        return this.metadata.name;
    }
}
exports.TypeStructFieldNode = TypeStructFieldNode;
function isTypeStructFieldNode(node) {
    return !!node && node.nodeClass === 'TypeStructFieldNode';
}
exports.isTypeStructFieldNode = isTypeStructFieldNode;
function assertTypeStructFieldNode(node) {
    var _a;
    if (!isTypeStructFieldNode(node)) {
        throw new Error(`Expected TypeStructFieldNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeStructFieldNode = assertTypeStructFieldNode;
//# sourceMappingURL=TypeStructFieldNode.js.map