"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeStructNode = exports.isTypeStructNode = exports.TypeStructNode = void 0;
const utils_1 = require("../utils");
const TypeStructFieldNode_1 = require("./TypeStructFieldNode");
class TypeStructNode {
    constructor(name, fields) {
        this.nodeClass = 'TypeStructNode';
        this.name = (0, utils_1.mainCase)(name);
        this.fields = fields;
    }
    static fromIdl(idl) {
        var _a, _b;
        return new TypeStructNode((_a = idl.name) !== null && _a !== void 0 ? _a : '', ((_b = idl.fields) !== null && _b !== void 0 ? _b : []).map(TypeStructFieldNode_1.TypeStructFieldNode.fromIdl));
    }
    accept(visitor) {
        return visitor.visitTypeStruct(this);
    }
}
exports.TypeStructNode = TypeStructNode;
function isTypeStructNode(node) {
    return !!node && node.nodeClass === 'TypeStructNode';
}
exports.isTypeStructNode = isTypeStructNode;
function assertTypeStructNode(node) {
    var _a;
    if (!isTypeStructNode(node)) {
        throw new Error(`Expected TypeStructNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeStructNode = assertTypeStructNode;
//# sourceMappingURL=TypeStructNode.js.map