"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeTupleNode = exports.isTypeTupleNode = exports.TypeTupleNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeTupleNode {
    constructor(itemTypes) {
        this.nodeClass = 'TypeTupleNode';
        this.itemTypes = itemTypes;
    }
    static fromIdl(idl) {
        return new TypeTupleNode(idl.tuple.map(TypeNode_1.createTypeNodeFromIdl));
    }
    accept(visitor) {
        return visitor.visitTypeTuple(this);
    }
}
exports.TypeTupleNode = TypeTupleNode;
function isTypeTupleNode(node) {
    return !!node && node.nodeClass === 'TypeTupleNode';
}
exports.isTypeTupleNode = isTypeTupleNode;
function assertTypeTupleNode(node) {
    var _a;
    if (!isTypeTupleNode(node)) {
        throw new Error(`Expected TypeTupleNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeTupleNode = assertTypeTupleNode;
//# sourceMappingURL=TypeTupleNode.js.map