"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertTypeVecNode = exports.isTypeVecNode = exports.TypeVecNode = void 0;
const TypeNode_1 = require("./TypeNode");
class TypeVecNode {
    constructor(itemType) {
        this.nodeClass = 'TypeVecNode';
        this.itemType = itemType;
    }
    static fromIdl(idl) {
        return new TypeVecNode((0, TypeNode_1.createTypeNodeFromIdl)(idl.vec));
    }
    accept(visitor) {
        return visitor.visitTypeVec(this);
    }
}
exports.TypeVecNode = TypeVecNode;
function isTypeVecNode(node) {
    return !!node && node.nodeClass === 'TypeVecNode';
}
exports.isTypeVecNode = isTypeVecNode;
function assertTypeVecNode(node) {
    var _a;
    if (!isTypeVecNode(node)) {
        throw new Error(`Expected TypeVecNode, got ${(_a = node === null || node === void 0 ? void 0 : node.nodeClass) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertTypeVecNode = assertTypeVecNode;
//# sourceMappingURL=TypeVecNode.js.map