"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.vEnum = exports.vStruct = exports.vSome = exports.vNone = exports.vMap = exports.vSet = exports.vTuple = exports.vList = exports.vPublicKey = exports.vScalar = void 0;
const vScalar = (scalar) => {
    if (typeof scalar === 'number')
        return { __kind: 'number', value: scalar };
    if (typeof scalar === 'boolean')
        return { __kind: 'boolean', value: scalar };
    return { __kind: 'string', value: scalar };
};
exports.vScalar = vScalar;
const vPublicKey = (value) => ({
    __kind: 'publicKey',
    value,
});
exports.vPublicKey = vPublicKey;
const vList = (values) => ({
    __kind: 'list',
    values,
});
exports.vList = vList;
const vTuple = (values) => ({
    __kind: 'tuple',
    values,
});
exports.vTuple = vTuple;
const vSet = (values) => ({
    __kind: 'set',
    values,
});
exports.vSet = vSet;
const vMap = (values) => ({
    __kind: 'map',
    values,
});
exports.vMap = vMap;
const vNone = () => ({ __kind: 'optionNone' });
exports.vNone = vNone;
const vSome = (value) => ({
    __kind: 'optionSome',
    value,
});
exports.vSome = vSome;
const vStruct = (values) => ({
    __kind: 'struct',
    values,
});
exports.vStruct = vStruct;
const vEnum = (enumType, variant, value, dependency) => ({
    __kind: 'enum',
    enumType,
    variant,
    value: value !== null && value !== void 0 ? value : null,
    dependency: dependency !== null && dependency !== void 0 ? dependency : null,
});
exports.vEnum = vEnum;
//# sourceMappingURL=ValueNode.js.map