"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RenderJavaScriptVisitor = void 0;
const visitors_1 = require("../../visitors");
const utils_1 = require("../utils");
const WriteRenderMapVisitor_1 = require("../WriteRenderMapVisitor");
const GetJavaScriptRenderMapVisitor_1 = require("./GetJavaScriptRenderMapVisitor");
const GetJavaScriptValidatorBagVisitor_1 = require("./GetJavaScriptValidatorBagVisitor");
class RenderJavaScriptVisitor extends visitors_1.BaseThrowVisitor {
    constructor(path, options = {}) {
        super();
        this.path = path;
        this.options = options;
    }
    visitRoot(root) {
        var _a;
        // Validate nodes.
        root.accept(new visitors_1.ThrowValidatorItemsVisitor(new GetJavaScriptValidatorBagVisitor_1.GetJavaScriptValidatorBagVisitor(), this.options.throwLevel));
        // Delete existing generated folder.
        if ((_a = this.options.deleteFolderBeforeRendering) !== null && _a !== void 0 ? _a : true) {
            (0, utils_1.deleteFolder)(this.path);
        }
        // Render the new files.
        new WriteRenderMapVisitor_1.WriteRenderMapVisitor(new GetJavaScriptRenderMapVisitor_1.GetJavaScriptRenderMapVisitor(this.options), this.path).visitRoot(root);
    }
}
exports.RenderJavaScriptVisitor = RenderJavaScriptVisitor;
//# sourceMappingURL=RenderJavaScriptVisitor.js.map