"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseDelegateVisitor = void 0;
class BaseDelegateVisitor {
    constructor(visitor) {
        this.visitor = visitor;
    }
    visitRoot(root) {
        return this.map(root.accept(this.visitor));
    }
    visitProgram(program) {
        return this.map(program.accept(this.visitor));
    }
    visitAccount(account) {
        return this.map(account.accept(this.visitor));
    }
    visitInstruction(instruction) {
        return this.map(instruction.accept(this.visitor));
    }
    visitDefinedType(definedType) {
        return this.map(definedType.accept(this.visitor));
    }
    visitError(error) {
        return this.map(error.accept(this.visitor));
    }
    visitTypeArray(typeArray) {
        return this.map(typeArray.accept(this.visitor));
    }
    visitTypeDefinedLink(typeDefinedLink) {
        return this.map(typeDefinedLink.accept(this.visitor));
    }
    visitTypeEnum(typeEnum) {
        return this.map(typeEnum.accept(this.visitor));
    }
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant) {
        return this.map(typeEnumEmptyVariant.accept(this.visitor));
    }
    visitTypeEnumStructVariant(typeEnumStructVariant) {
        return this.map(typeEnumStructVariant.accept(this.visitor));
    }
    visitTypeEnumTupleVariant(typeEnumTupleVariant) {
        return this.map(typeEnumTupleVariant.accept(this.visitor));
    }
    visitTypeLeaf(typeLeaf) {
        return this.map(typeLeaf.accept(this.visitor));
    }
    visitTypeLeafWrapper(typeLeafWrapper) {
        return this.map(typeLeafWrapper.accept(this.visitor));
    }
    visitTypeMap(typeMap) {
        return this.map(typeMap.accept(this.visitor));
    }
    visitTypeOption(typeOption) {
        return this.map(typeOption.accept(this.visitor));
    }
    visitTypeSet(typeSet) {
        return this.map(typeSet.accept(this.visitor));
    }
    visitTypeStruct(typeStruct) {
        return this.map(typeStruct.accept(this.visitor));
    }
    visitTypeStructField(typeStructField) {
        return this.map(typeStructField.accept(this.visitor));
    }
    visitTypeTuple(typeTuple) {
        return this.map(typeTuple.accept(this.visitor));
    }
    visitTypeVec(typeVec) {
        return this.map(typeVec.accept(this.visitor));
    }
}
exports.BaseDelegateVisitor = BaseDelegateVisitor;
//# sourceMappingURL=BaseDelegateVisitor.js.map