export type IdlType = IdlTypeDefinedLink | IdlTypeOption | IdlTypeTuple | IdlTypeVec | IdlTypeArray | IdlTypeMap | IdlTypeSet | IdlTypeStruct | IdlTypeEnum | IdlTypeLeaf;
export type IdlTypeDefinedLink = {
    defined: string;
};
export type IdlTypeOption = {
    option: IdlType;
} | {
    coption: IdlType;
};
export type IdlTypeTuple = {
    tuple: IdlType[];
};
export type IdlTypeVec = {
    vec: IdlType;
};
export type IdlTypeArray = {
    array: [idlType: IdlType, size: number];
};
export type IdlTypeMap = IdlTypeHashMap | IdlTypeBTreeMap;
export type IdlTypeHashMap = {
    hashMap: [IdlType, IdlType];
};
export type IdlTypeBTreeMap = {
    bTreeMap: [IdlType, IdlType];
};
export type IdlTypeSet = IdlTypeHashSet | IdlTypeBTreeSet;
export type IdlTypeHashSet = {
    hashSet: IdlType;
};
export type IdlTypeBTreeSet = {
    bTreeSet: IdlType;
};
export type IdlTypeStruct = {
    kind: 'struct';
    name?: string;
    fields: IdlTypeStructField[];
};
export type IdlTypeStructField = {
    name: string;
    type: IdlType;
    docs?: string[];
    defaultsValue?: any;
};
export type IdlTypeEnum = {
    kind: 'enum';
    name?: string;
    variants: IdlTypeEnumVariant[];
};
export type IdlTypeEnumVariant = {
    name: string;
    fields?: IdlTypeEnumFields;
};
export type IdlTypeEnumFields = IdlTypeEnumField[] | IdlType[];
export type IdlTypeEnumField = {
    name: string;
    type: IdlType;
    docs?: string[];
};
export type IdlTypeLeaf = IdlTypeNumber | 'string' | 'publicKey' | 'bytes';
export type IdlTypeNumber = 'bool' | 'u8' | 'u16' | 'u32' | 'u64' | 'u128' | 'i8' | 'i16' | 'i32' | 'i64' | 'i128' | 'f32' | 'f64';
