import type { IdlDefinedType } from '../idl';
import type { Dependency, Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import type { TypeEnumNode } from './TypeEnumNode';
import type { TypeStructNode } from './TypeStructNode';
export type DefinedTypeNodeMetadata = {
    name: string;
    idlName: string;
    docs: string[];
    importFrom: Dependency;
    internal: boolean;
};
export declare class DefinedTypeNode implements Visitable {
    readonly nodeClass: "DefinedTypeNode";
    readonly metadata: DefinedTypeNodeMetadata;
    readonly type: TypeStructNode | TypeEnumNode;
    constructor(metadata: DefinedTypeNodeMetadata, type: TypeStructNode | TypeEnumNode);
    static fromIdl(idl: Partial<IdlDefinedType>): DefinedTypeNode;
    accept<T>(visitor: Visitor<T>): T;
    get name(): string;
    get docs(): string[];
}
export declare function isDefinedTypeNode(node: Node | null): node is DefinedTypeNode;
export declare function assertDefinedTypeNode(node: Node | null): asserts node is DefinedTypeNode;
