import type { IdlTypeArray } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export declare class TypeArrayNode implements Visitable {
    readonly nodeClass: "TypeArrayNode";
    readonly itemType: TypeNode;
    readonly size: number;
    constructor(itemType: TypeNode, size: number);
    static fromIdl(idl: IdlTypeArray): TypeArrayNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeArrayNode(node: Node | null): node is TypeArrayNode;
export declare function assertTypeArrayNode(node: Node | null): asserts node is TypeArrayNode;
