import type { Dependency, Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
export declare class TypeDefinedLinkNode implements Visitable {
    readonly nodeClass: "TypeDefinedLinkNode";
    readonly definedType: string;
    readonly dependency: Dependency | null;
    constructor(definedType: string, dependency?: Dependency | null);
    accept<T>(visitor: Visitor<T>): T;
    get name(): string;
}
export declare function isTypeDefinedLinkNode(node: Node | null): node is TypeDefinedLinkNode;
export declare function assertTypeDefinedLinkNode(node: Node | null): asserts node is TypeDefinedLinkNode;
