import type { IdlTypeEnum } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import type { TypeEnumVariantNode } from './TypeEnumVariantNode';
export declare class TypeEnumNode implements Visitable {
    readonly nodeClass: "TypeEnumNode";
    readonly name: string;
    readonly variants: TypeEnumVariantNode[];
    constructor(name: string, variants: TypeEnumVariantNode[]);
    static fromIdl(idl: IdlTypeEnum): TypeEnumNode;
    accept<T>(visitor: Visitor<T>): T;
    isScalarEnum(): boolean;
    isDataEnum(): boolean;
}
export declare function isTypeEnumNode(node: Node | null): node is TypeEnumNode;
export declare function assertTypeEnumNode(node: Node | null): asserts node is TypeEnumNode;
