import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
export declare const LEAF_TYPES: readonly ["string", "publicKey", "bytes", "bool", "u8", "u16", "u32", "u64", "u128", "i8", "i16", "i32", "i64", "i128", "f32", "f64"];
export type LeafType = typeof LEAF_TYPES[number];
export declare class TypeLeafNode implements Visitable {
    readonly nodeClass: "TypeLeafNode";
    readonly type: LeafType;
    constructor(type: LeafType);
    static isValidType(type: string): type is LeafType;
    accept<T>(visitor: Visitor<T>): T;
    isSignedInteger(): boolean;
    isUnsignedInteger(): boolean;
    isInteger(): boolean;
    isDecimal(): boolean;
    isNumber(): boolean;
}
export declare function isTypeLeafNode(node: Node | null): node is TypeLeafNode;
export declare function assertTypeLeafNode(node: Node | null): asserts node is TypeLeafNode;
