import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import type { TypeLeafNode } from './TypeLeafNode';
export type LeafWrapper = {
    kind: 'DateTime';
} | {
    kind: 'SolAmount';
} | {
    kind: 'Amount';
    identifier: string;
    decimals: number;
};
export declare class TypeLeafWrapperNode implements Visitable {
    readonly nodeClass: "TypeLeafWrapperNode";
    readonly wrapper: LeafWrapper;
    readonly leaf: TypeLeafNode;
    constructor(wrapper: LeafWrapper, leaf: TypeLeafNode);
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeLeafWrapperNode(node: Node | null): node is TypeLeafWrapperNode;
export declare function assertTypeLeafWrapperNode(node: Node | null): asserts node is TypeLeafWrapperNode;
