import type { IdlTypeMap } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import { TypeNode } from './TypeNode';
import type { Node } from './Node';
export declare class TypeMapNode implements Visitable {
    readonly nodeClass: "TypeMapNode";
    readonly mapType: 'hashMap' | 'bTreeMap';
    readonly keyType: TypeNode;
    readonly valueType: TypeNode;
    constructor(mapType: 'hashMap' | 'bTreeMap', keyType: TypeNode, valueType: TypeNode);
    static fromIdl(idl: IdlTypeMap): TypeMapNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeMapNode(node: Node | null): node is TypeMapNode;
export declare function assertTypeMapNode(node: Node | null): asserts node is TypeMapNode;
