import type { IdlType } from '../idl';
import type { Node } from './Node';
import { TypeArrayNode } from './TypeArrayNode';
import { TypeDefinedLinkNode } from './TypeDefinedLinkNode';
import { TypeEnumNode } from './TypeEnumNode';
import { TypeLeafNode } from './TypeLeafNode';
import { TypeLeafWrapperNode } from './TypeLeafWrapperNode';
import { TypeMapNode } from './TypeMapNode';
import { TypeOptionNode } from './TypeOptionNode';
import { TypeSetNode } from './TypeSetNode';
import { TypeStructNode } from './TypeStructNode';
import { TypeTupleNode } from './TypeTupleNode';
import { TypeVecNode } from './TypeVecNode';
export type TypeNode = TypeArrayNode | TypeDefinedLinkNode | TypeEnumNode | TypeLeafNode | TypeLeafWrapperNode | TypeMapNode | TypeOptionNode | TypeSetNode | TypeStructNode | TypeTupleNode | TypeVecNode;
export declare const createTypeNodeFromIdl: (idlType: IdlType) => TypeNode;
export declare function isTypeNode(node: Node | null): node is TypeNode;
export declare function assertTypeNode(node: Node | null): asserts node is TypeNode;
export declare function isTypeStructOrEnumNode(node: Node | null): node is TypeStructNode | TypeEnumNode;
export declare function assertTypeStructOrEnumNode(node: Node | null): asserts node is TypeStructNode | TypeEnumNode;
