import type { IdlTypeOption } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import { TypeNode } from './TypeNode';
import type { Node } from './Node';
export declare class TypeOptionNode implements Visitable {
    readonly nodeClass: "TypeOptionNode";
    readonly optionType: 'option' | 'coption';
    readonly type: TypeNode;
    constructor(optionType: 'option' | 'coption', type: TypeNode);
    static fromIdl(idl: IdlTypeOption): TypeOptionNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeOptionNode(node: Node | null): node is TypeOptionNode;
export declare function assertTypeOptionNode(node: Node | null): asserts node is TypeOptionNode;
