import type { IdlTypeSet } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import { TypeNode } from './TypeNode';
import type { Node } from './Node';
export declare class TypeSetNode implements Visitable {
    readonly nodeClass: "TypeSetNode";
    readonly setType: 'hashSet' | 'bTreeSet';
    readonly type: TypeNode;
    constructor(setType: 'hashSet' | 'bTreeSet', type: TypeNode);
    static fromIdl(idl: IdlTypeSet): TypeSetNode;
    accept<T>(visitor: Visitor<T>): T;
}
export declare function isTypeSetNode(node: Node | null): node is TypeSetNode;
export declare function assertTypeSetNode(node: Node | null): asserts node is TypeSetNode;
