import type { IdlTypeStructField } from '../idl';
import type { Visitable, Visitor } from '../visitors';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
import { ValueNode } from './ValueNode';
export type TypeStructFieldNodeMetadata = {
    name: string;
    docs: string[];
    defaultsTo: {
        strategy: 'optional' | 'omitted';
        value: ValueNode;
    } | null;
};
export declare class TypeStructFieldNode implements Visitable {
    readonly nodeClass: "TypeStructFieldNode";
    readonly metadata: TypeStructFieldNodeMetadata;
    readonly type: TypeNode;
    constructor(metadata: TypeStructFieldNodeMetadata, type: TypeNode);
    static fromIdl(idl: IdlTypeStructField): TypeStructFieldNode;
    accept<T>(visitor: Visitor<T>): T;
    get name(): string;
}
export declare function isTypeStructFieldNode(node: Node | null): node is TypeStructFieldNode;
export declare function assertTypeStructFieldNode(node: Node | null): asserts node is TypeStructFieldNode;
