import * as nodes from '../../nodes';
import { GetDefaultValidatorBagVisitor, NodeStack, ValidatorBag } from '../../visitors';
export declare class GetJavaScriptValidatorBagVisitor extends GetDefaultValidatorBagVisitor {
    protected exportMap: Map<string, {
        node: nodes.Node;
        stack: NodeStack;
        exportType: string;
    }>;
    visitRoot(root: nodes.RootNode): ValidatorBag;
    visitProgram(program: nodes.ProgramNode): ValidatorBag;
    visitAccount(account: nodes.AccountNode): ValidatorBag;
    visitInstruction(instruction: nodes.InstructionNode): ValidatorBag;
    visitDefinedType(definedType: nodes.DefinedTypeNode): ValidatorBag;
    visitError(error: nodes.ErrorNode): ValidatorBag;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): ValidatorBag;
    protected checkExportConflicts(node: nodes.Node, exports: Record<string, string>): ValidatorBag;
    protected isEponymousExport(node: nodes.Node, exportName: string): boolean;
    protected getNodeTitle(node: nodes.Node): string;
}
