import type * as nodes from '../nodes';
import { Visitor } from './Visitor';
export declare abstract class BaseDelegateVisitor<T, U> implements Visitor<U> {
    readonly visitor: Visitor<T>;
    constructor(visitor: Visitor<T>);
    abstract map(value: T): U;
    visitRoot(root: nodes.RootNode): U;
    visitProgram(program: nodes.ProgramNode): U;
    visitAccount(account: nodes.AccountNode): U;
    visitInstruction(instruction: nodes.InstructionNode): U;
    visitDefinedType(definedType: nodes.DefinedTypeNode): U;
    visitError(error: nodes.ErrorNode): U;
    visitTypeArray(typeArray: nodes.TypeArrayNode): U;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): U;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): U;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): U;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): U;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): U;
    visitTypeLeaf(typeLeaf: nodes.TypeLeafNode): U;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): U;
    visitTypeMap(typeMap: nodes.TypeMapNode): U;
    visitTypeOption(typeOption: nodes.TypeOptionNode): U;
    visitTypeSet(typeSet: nodes.TypeSetNode): U;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): U;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): U;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): U;
    visitTypeVec(typeVec: nodes.TypeVecNode): U;
}
