import type { Visitor } from './Visitor';
import * as nodes from '../nodes';
export declare class BaseNodeVisitor implements Visitor<nodes.Node> {
    visitRoot(root: nodes.RootNode): nodes.Node;
    visitProgram(program: nodes.ProgramNode): nodes.Node;
    visitAccount(account: nodes.AccountNode): nodes.Node;
    visitInstruction(instruction: nodes.InstructionNode): nodes.Node;
    visitDefinedType(definedType: nodes.DefinedTypeNode): nodes.Node;
    visitError(error: nodes.ErrorNode): nodes.Node;
    visitTypeArray(typeArray: nodes.TypeArrayNode): nodes.Node;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): nodes.Node;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): nodes.Node;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): nodes.Node;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): nodes.Node;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): nodes.Node;
    visitTypeLeaf(typeLeaf: nodes.TypeLeafNode): nodes.Node;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): nodes.Node;
    visitTypeMap(typeMap: nodes.TypeMapNode): nodes.Node;
    visitTypeOption(typeOption: nodes.TypeOptionNode): nodes.Node;
    visitTypeSet(typeSet: nodes.TypeSetNode): nodes.Node;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): nodes.Node;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): nodes.Node;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): nodes.Node;
    visitTypeVec(typeVec: nodes.TypeVecNode): nodes.Node;
}
