import * as nodes from '../nodes';
import type { Visitor } from './Visitor';
export declare class BaseThrowVisitor<T> implements Visitor<T> {
    visitRoot(root: nodes.RootNode): T;
    visitProgram(program: nodes.ProgramNode): T;
    visitAccount(account: nodes.AccountNode): T;
    visitInstruction(instruction: nodes.InstructionNode): T;
    visitDefinedType(definedType: nodes.DefinedTypeNode): T;
    visitError(error: nodes.ErrorNode): T;
    visitTypeArray(typeArray: nodes.TypeArrayNode): T;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): T;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): T;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): T;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): T;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): T;
    visitTypeLeaf(typeLeaf: nodes.TypeLeafNode): T;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): T;
    visitTypeMap(typeMap: nodes.TypeMapNode): T;
    visitTypeOption(typeOption: nodes.TypeOptionNode): T;
    visitTypeSet(typeSet: nodes.TypeSetNode): T;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): T;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): T;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): T;
    visitTypeVec(typeVec: nodes.TypeVecNode): T;
}
