import * as nodes from '../nodes';
import type { Visitor } from './Visitor';
export declare abstract class BaseVoidVisitor implements Visitor<void> {
    visitRoot(root: nodes.RootNode): void;
    visitProgram(program: nodes.ProgramNode): void;
    visitAccount(account: nodes.AccountNode): void;
    visitInstruction(instruction: nodes.InstructionNode): void;
    visitDefinedType(definedType: nodes.DefinedTypeNode): void;
    visitError(error: nodes.ErrorNode): void;
    visitTypeArray(typeArray: nodes.TypeArrayNode): void;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): void;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): void;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): void;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): void;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): void;
    visitTypeLeaf(typeLeaf: nodes.TypeLeafNode): void;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): void;
    visitTypeMap(typeMap: nodes.TypeMapNode): void;
    visitTypeOption(typeOption: nodes.TypeOptionNode): void;
    visitTypeSet(typeSet: nodes.TypeSetNode): void;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): void;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): void;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): void;
    visitTypeVec(typeVec: nodes.TypeVecNode): void;
}
