import * as nodes from '../../nodes';
import { NodeStack } from '../NodeStack';
import { ValidatorBag } from '../ValidatorBag';
import { Visitor } from '../Visitor';
export declare class GetDefaultValidatorBagVisitor implements Visitor<ValidatorBag> {
    protected stack: NodeStack;
    protected program: nodes.ProgramNode | null;
    protected definedTypes: Set<string>;
    visitRoot(root: nodes.RootNode): ValidatorBag;
    visitProgram(program: nodes.ProgramNode): ValidatorBag;
    visitAccount(account: nodes.AccountNode): ValidatorBag;
    visitInstruction(instruction: nodes.InstructionNode): ValidatorBag;
    visitDefinedType(definedType: nodes.DefinedTypeNode): ValidatorBag;
    visitError(error: nodes.ErrorNode): ValidatorBag;
    visitTypeArray(typeArray: nodes.TypeArrayNode): ValidatorBag;
    visitTypeDefinedLink(typeDefinedLink: nodes.TypeDefinedLinkNode): ValidatorBag;
    visitTypeEnum(typeEnum: nodes.TypeEnumNode): ValidatorBag;
    visitTypeEnumEmptyVariant(typeEnumEmptyVariant: nodes.TypeEnumEmptyVariantNode): ValidatorBag;
    visitTypeEnumStructVariant(typeEnumStructVariant: nodes.TypeEnumStructVariantNode): ValidatorBag;
    visitTypeEnumTupleVariant(typeEnumTupleVariant: nodes.TypeEnumTupleVariantNode): ValidatorBag;
    visitTypeLeaf(typeLeaf: nodes.TypeLeafNode): ValidatorBag;
    visitTypeLeafWrapper(typeLeafWrapper: nodes.TypeLeafWrapperNode): ValidatorBag;
    visitTypeMap(typeMap: nodes.TypeMapNode): ValidatorBag;
    visitTypeOption(typeOption: nodes.TypeOptionNode): ValidatorBag;
    visitTypeSet(typeSet: nodes.TypeSetNode): ValidatorBag;
    visitTypeStruct(typeStruct: nodes.TypeStructNode): ValidatorBag;
    visitTypeStructField(typeStructField: nodes.TypeStructFieldNode): ValidatorBag;
    visitTypeTuple(typeTuple: nodes.TypeTupleNode): ValidatorBag;
    visitTypeVec(typeVec: nodes.TypeVecNode): ValidatorBag;
    protected pushNode(node: nodes.Node): void;
    protected popNode(): nodes.Node | undefined;
}
