import * as nodes from '../../nodes';
import { BaseNodeVisitor } from '../BaseNodeVisitor';
import { Dependency } from '../Dependency';
export type InstructionNodeAccountDefaultsInput = nodes.InstructionNodeAccountDefaults | {
    kind: 'pda';
    pdaAccount?: string;
    dependency?: Dependency;
    seeds?: Record<string, nodes.InstructionNodeAccountDefaultsSeed>;
};
export type InstructionAccountDefaultRule = InstructionNodeAccountDefaultsInput & {
    /** The name of the instruction account or a pattern to match on it. */
    account: string | RegExp;
    /** @defaultValue Defaults to searching accounts on all instructions. */
    instruction?: string;
    /** @defaultValue `false`. */
    ignoreIfOptional?: boolean;
};
export declare const DEFAULT_INSTRUCTION_ACCOUNT_DEFAULT_RULES: InstructionAccountDefaultRule[];
export declare class SetInstructionAccountDefaultValuesVisitor extends BaseNodeVisitor {
    protected readonly rules: InstructionAccountDefaultRule[];
    protected allAccounts: Map<string, nodes.AccountNode>;
    constructor(rules: InstructionAccountDefaultRule[]);
    visitRoot(root: nodes.RootNode): nodes.Node;
    visitProgram(program: nodes.ProgramNode): nodes.Node;
    visitInstruction(instruction: nodes.InstructionNode): nodes.Node;
    protected matchRule(instruction: nodes.InstructionNode, account: nodes.InstructionNodeAccount): InstructionAccountDefaultRule | undefined;
}
